/*
 * PictNode is a class representing a drawn picture
 * node in a scene tree.
 **/
public class PictNode extends DrawableNode {
  /**
   * The picture I'm associated with
   **/
  Picture myPict;
  
  /*
   * Make me with this picture
   * @param pict the Picture I'm associated with
   **/
  public PictNode(Picture pict){
    super(); // Call superclass constructor
    myPict = pict;
  }

  /**
   * Method to return a string with informaiton 
   * about this node
   */
  public String toString() 
  {
    return "PictNode (with picture: "+myPict+" and next: "+next;
  }

  /*
   * Use the given turtle to draw oneself
   * @param pen the Turtle to draw with
   **/
  public void drawWith(Turtle pen){
    pen.drop(myPict);
  }
}
