public class SoundTreeExample {

  ScaleBranch scaledBranch; // Needed between methods
  
  SoundBranch root;
  public SoundBranch root(){return root;}
  
  public void setUp() {
    FileChooser.setMediaPath("D:/cs1316/MediaSources/");
    Sound clap = new Sound(FileChooser.getMediaPath("clap-q.wav"));
    Sound chirp = new Sound(FileChooser.getMediaPath("chirp-2.wav"));
    Sound rest = new Sound(FileChooser.getMediaPath("rest-1.wav"));
    Sound snap = new Sound(FileChooser.getMediaPath("snap-tenth.wav"));
    Sound clink = new Sound(FileChooser.getMediaPath("clink-tenth.wav"));
    Sound clave = new Sound(FileChooser.getMediaPath("clave-twentieth.wav"));
    Sound gong = new Sound(FileChooser.getMediaPath("gongb-2.wav"));
    
    root = new SoundBranch();
    SoundNode sn;
    
    SoundBranch branch1 = new SoundBranch();
    sn = new SoundNode(clap.append(rest).append(snap));
    branch1.addChild(sn);
    sn = new SoundNode(rest.append(snap).append(rest));
    branch1.addChild(sn);
 
    scaledBranch = new ScaleBranch(1.0);
    sn = new SoundNode(clink.append(clave).append(gong));
    scaledBranch.addChild(sn);
    sn = new SoundNode(rest.append(chirp).append(clap));
    scaledBranch.addChild(sn);

    SoundBranch branch2 = new SoundBranch();
    sn = new SoundNode(clap.append(snap).append(snap));
    branch2.addChild(sn);
    sn = new SoundNode(rest.append(snap).append(clap));
    branch2.addChild(sn);

    root.addChild(branch1); 
    root.addChild(scaledBranch);
    root.addChild(branch2);
  }
  
  public void play(){
    root.playFromMeOn();
  }

  public void playScaled(double factor){
    scaledBranch.setFactor(factor);
    root.playFromMeOn();
  }

  public void playAfter(){
    root.collectAfter().play();
  }
}
